"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = __importDefault(require("./types"));
var config = {
    rules: [
        {
            key: 'round|floor|ceil|asin|acos|atan|sin|cos|tan|cot|log|sqrt|min|max|pow|exp|abs|acc|diff|defined|deg|set',
            data: {
                type: types_1.default.NAMED_FUNCTION,
                args: 1,
                precedence: 5
            }
        },
        {
            key: 'PI|pi',
            data: {
                type: types_1.default.CONSTANT
            }
        },
        {
            key: '\\*\\*',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\<\\=',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\>\\=',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\=\\=\\=',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\!\\=\\=',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\!',
            data: {
                type: types_1.default.NAMED_FUNCTION,
                args: 1,
                precedence: 4
            }
        },
        {
            key: '\\>',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\<',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\|\\|',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '\\&\\&',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '[\\*\\/\\%]',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 2
            }
        },
        {
            key: '[\\+\\,]',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 1
            }
        },
        {
            key: '\\-(?![0-9.,])',
            data: {
                type: types_1.default.OPERATOR,
                args: 2,
                precedence: 1
            }
        },
        { key: '[(\\[]', data: { type: types_1.default.LEFT_PARENTHESIS } },
        {
            key: '\\?',
            data: { type: types_1.default.OPERATOR, args: 2, precedence: -1 }
        },
        {
            key: '\\:',
            data: { type: types_1.default.OPERATOR, args: 2, precedence: 0 }
        },
        { key: '[)\\]]', data: { type: types_1.default.RIGHT_PARENTHESIS } },
        { key: '[0-9.,-]+', data: { type: types_1.default.NUMBER } },
        { key: '[a-zA-Z]+', data: { type: types_1.default.VARIABLE } }
    ]
};
exports.default = config;
