"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ramda_1 = require("ramda");
var types_1 = __importDefault(require("./types"));
var isType = function (type) {
    return ramda_1.pipe(
    // @ts-ignore
    ramda_1.prop('type'), ramda_1.equals(type));
};
exports.isNumber = isType(types_1.default.NUMBER);
exports.isConstant = isType(types_1.default.CONSTANT);
exports.isVariable = isType(types_1.default.VARIABLE);
exports.isOperator = isType(types_1.default.OPERATOR);
exports.isNamedFunction = isType(types_1.default.NAMED_FUNCTION);
exports.isLeftParenthesis = isType(types_1.default.LEFT_PARENTHESIS);
exports.isRightParenthesis = isType(types_1.default.RIGHT_PARENTHESIS);
