"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ramda_1 = require("ramda");
var config_1 = __importDefault(require("../config"));
var rules_1 = require("./rules");
var token_1 = require("./token");
var unknown_1 = require("./unknown");
var utils_1 = require("./utils");
var applyRuleOnTarget = ramda_1.curry(function (_a, target) {
    var data = _a.data, key = _a.key;
    if (token_1.isToken(target)) {
        return target;
    }
    return utils_1.zipConcat(ramda_1.split(key, target), 
    // @ts-ignore
    ramda_1.map(token_1.buildToken(data), ramda_1.match(key, target)));
});
// @ts-ignore
var applyRuleOnTargets = function (targets, rule) {
    return ramda_1.pipe(
    // @ts-ignore
    ramda_1.map(applyRuleOnTarget(rule)), ramda_1.flatten, utils_1.compact
    // @ts-ignore
    )(targets);
};
var tokenize = ramda_1.pipe(utils_1.wrap, 
// @ts-ignore
ramda_1.reduce(applyRuleOnTargets, ramda_1.__, rules_1.rules(config_1.default)), ramda_1.reject(unknown_1.isUnknown));
exports.default = tokenize;
