var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=void 0;var _toConsumableArray2=_interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));var _reactNativeReanimated=_interopRequireDefault(require("react-native-reanimated"));var _InvalidExpressionError=require("./InvalidExpressionError");var _types=_interopRequireDefault(require("./simple-math-ast/types"));var _logPrefix=_interopRequireDefault(require("./log-prefix"));var reduceAst=function reduceAst(tree,variables,mathType){if(!tree){throw new _InvalidExpressionError.InvalidExpressionError('Could not parse');}if(tree.token.type===_types.default.NUMBER){return Number(tree.token.value);}if(tree.token.type===_types.default.CONSTANT){if(tree.token.value==='pi'||tree.token.value==='PI'){return Math.PI;}}if(tree.token.type===_types.default.VARIABLE){return variables[tree.token.value];}var left=reduceAst(tree.left,variables,mathType);if(tree.token.type===_types.default.NAMED_FUNCTION){if(tree.token.value==='log'){if(mathType==='reanimated'){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" log() is not supported by Reanimated");}return Math.log(left);}if(tree.token.value==='sin'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to sin()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.sin(left);}return Math.sin(left);}if(tree.token.value==='exp'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to exp()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.exp(left);}return Math.exp(left);}if(tree.token.value==='cos'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to cos()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.cos(left);}return Math.cos(left);}if(tree.token.value==='tan'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to tan()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.tan(left);}return Math.tan(left);}if(tree.token.value==='asin'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to asin()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.asin(left);}return Math.asin(left);}if(tree.token.value==='atan'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to atan()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.atan(left);}return Math.atan(left);}if(tree.token.value==='acos'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to acos()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.acos(left);}return Math.acos(left);}if(tree.token.value==='round'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to round()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.round(left);}return Math.round(left);}if(tree.token.value==='ceil'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to ceil()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.ceil(left);}return Math.ceil(left);}if(tree.token.value==='floor'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to floor()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.floor(left);}return Math.floor(left);}if(tree.token.value==='abs'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to abs()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.abs(left);}return Math.abs(left);}if(tree.token.value==='deg'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to deg()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.concat(left,'deg');}return left;}if(tree.token.value==='diff'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to diff()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.diff(left);}throw new TypeError('diff() is not supported by native JS math');}if(tree.token.value==='acc'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to acc()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.acc(left);}throw new TypeError('acc() is not supported by native JS math');}if(tree.token.value==='defined'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to defined()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.defined(left);}throw new TypeError('defined() is not supported by native JS math');}if(tree.token.value==='cot'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to cot()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.divide(1,_reactNativeReanimated.default.tan(left));}return 1/Math.tan(left);}if(tree.token.value==='sqrt'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot pass an array to sqrt()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.sqrt(left);}return Math.sqrt(left);}if(tree.token.value==='min'){if(!Array.isArray(left)||left.length<2){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Must pass multiple values to min()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.min.apply(_reactNativeReanimated.default,(0,_toConsumableArray2.default)(left));}return Math.min.apply(Math,(0,_toConsumableArray2.default)(left));}if(tree.token.value==='max'){if(!Array.isArray(left)||left.length<2){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Must pass multiple values to max()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.max.apply(_reactNativeReanimated.default,(0,_toConsumableArray2.default)(left));}return Math.max.apply(Math,(0,_toConsumableArray2.default)(left));}if(tree.token.value==='set'){if(!Array.isArray(left)||left.length!==2){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Must pass multiple two values to set()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.set(left[0],left[1]);}return left[1];}if(tree.token.value==='pow'){if(!Array.isArray(left)||left.length<2){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Must pass multiple values to pow()");}if(mathType==='reanimated'){return _reactNativeReanimated.default.pow.apply(_reactNativeReanimated.default,(0,_toConsumableArray2.default)(left));}return left.reduce(function(b,c,index){return index>0?Math.pow(b,c):c;},0);}if(tree.token.value==='!'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"!\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.not(left);}return Number(!left);}}var right=reduceAst(tree.right,variables,mathType);if(tree.token.value==='+'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"+\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.add(left,right);}return left+right;}if(tree.token.value==='-'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"-\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.sub(left,right);}return left-right;}if(tree.token.value==='/'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"/\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.divide(left,right);}return left/right;}if(tree.token.value==='**'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"**\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.pow(left,right);}return Math.pow(left,right);}if(tree.token.value==='*'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"*\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.multiply(left,right);}return left*right;}if(tree.token.value==='%'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"%\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.modulo(left,right);}return left%right;}if(tree.token.value==='||'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"||\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.or(left,right);}return left||right;}if(tree.token.value==='&&'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"&&\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.and(left,right);}return left&&right;}if(tree.token.value==='<'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"<\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.lessThan(left,right);}return Number(left<right);}if(tree.token.value==='>'){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \">\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.greaterThan(left,right);}return Number(left>right);}if(tree.token.value==='>='){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \">=\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.greaterOrEq(left,right);}return Number(left>=right);}if(tree.token.value==='<='){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"<=\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.lessOrEq(left,right);}return Number(left<=right);}if(tree.token.value==='==='){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"===\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.eq(left,right);}return Number(left===right);}if(tree.token.value==='!=='){if(Array.isArray(left)||Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError(_logPrefix.default+" Cannot use operator \"!==\" on array");}if(mathType==='reanimated'){return _reactNativeReanimated.default.neq(left,right);}return Number(left!==right);}if(tree.token.value===','){return[].concat((0,_toConsumableArray2.default)(Array.isArray(left)?left:[left]),(0,_toConsumableArray2.default)(Array.isArray(right)?right:[right]));}if(tree.token.value===':'){if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError('Left expression of ternary expression cannot be an array');}if(Array.isArray(right)){throw new _InvalidExpressionError.InvalidExpressionError('Right expression of ternary expression cannot be an array');}return[left,right];}if(tree.token.value==='?'){if(!Array.isArray(right)||right.length!==2){throw new _InvalidExpressionError.InvalidExpressionError('Right value of ? operator must be an array with 2 elements');}if(Array.isArray(left)){throw new _InvalidExpressionError.InvalidExpressionError('Left value of ? operator must cannot be an array');}return _reactNativeReanimated.default.cond(left,right[0],right[1]);}throw new Error("Could not parse! Operator: "+tree.token.value);};var _default=reduceAst;exports.default=_default;
//# sourceMappingURL=reduce-ast.js.map